package com.chelvc.framework.nacos.config;

import java.util.Collections;

import com.alibaba.nacos.spring.context.annotation.config.NacosPropertySource;
import com.alibaba.nacos.spring.context.event.config.NacosConfigReceivedEvent;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.context.environment.EnvironmentChangeEvent;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationListener;
import org.springframework.context.annotation.Configuration;

/**
 * Nacos配置中心配置
 *
 * @author Woody
 * @date 2024/1/30
 */
@Configuration
@RequiredArgsConstructor(onConstructor = @__(@Autowired))
@NacosPropertySource(dataId = "${nacos.config.id:${spring.application.name}}",
        groupId = "${nacos.config.group:DEFAULT_GROUP}", autoRefreshed = true)
public class NacosConfigConfigurer implements ApplicationListener<NacosConfigReceivedEvent> {
    private final ApplicationContext applicationContext;

    @Override
    public void onApplicationEvent(NacosConfigReceivedEvent event) {
        this.applicationContext.publishEvent(new EnvironmentChangeEvent(Collections.emptySet()));
    }
}
